﻿
Structure hash
  Val1.i
  Val2.i
  Val3.i
  Val4.i
  Val5.i
  Val6.i
  *val7
  key_unique.i
EndStructure
;cluster est composée comme suit:
;*mem nombre d'élement utilisés dans le cluster courant
;*mem+4 adresse du cluster suivant
;début des données 8 élements de 4 octets chacun

ProcedureDLL SuperiorPower2(number.i)
  EnableASM
  MOV ebx,[p.v_number]
  BSR ecx,ebx
  MOV eax,1
  SAL eax,cl
  cmp eax,ebx
  Je _suite
  SAL eax,1
  !_suite:
  ProcedureReturn
  DisableASM
EndProcedure

;0 à c1max-1 cad pour c1max=10 0-9
ProcedureDLL Hash_New(nbS.i,nbli.i,keym.i)
  *mem=0
  Global nbSlot.i=SuperiorPower2(nbS)
  Global datas.i=SuperiorPower2(SizeOf(hash))
  Global keymax.i=keym
  Global ligne.i=nbli
  Global sz.i=SizeOf(hash)/SizeOf(*mem)
  Global size_cluster.i=ligne*datas+SizeOf(*mem)+SizeOf(*mem) ;32*16+16 =544
  Global sz.i=SizeOf(hash)/SizeOf(*mem) ;nombre de double mots copiés : 8
  FreeMemory(AllocateMemory(SizeOf(*mem))) ; pour charger les librairies pb nécessaire, sinon cette ligne ne sert à rien
  ;create memory space for nbslots simple chained lists
  *mem=AllocateMemory(nbSlot*size_cluster)
  ProcedureReturn *mem
EndProcedure

ProcedureDLL Hash_Add(*mem,keyX.i,keyY.i,Val1.i,Val2.i,Val3.i,Val4.i,Val5.i,val6.i,*val7,key_unique.i)
  EnableASM
  MOV    eax,dword [p.v_keyX] ;1
  MOV    ebx,dword [p.v_keyY] ;2
  MUL    dword [v_keymax] ;1x10000
  ADD    eax,ebx ;eax= 10000+2

  MOV    dword [p.v_key_unique],eax ;clé complete
  ;compression du hash en adresse
  !XOr    edx,edx
  DIV    dword [v_nbSlot] ;1002 modulo 8 = 2
  IMUL   edx,dword [v_size_cluster] ;2x 488 = 976
  ADD    edx,dword [p.p_mem] ;976 + adresse de base
  MOV    ebp,edx
  MOV    ebx,dword [p.v_key_unique]

  !XOr esi,esi ;met à zero esi qui contiendra la derniere adresse de ligne vide rencontrée
  !XOr edi,edi ;met à zero edi qui contiendra l'adresse du dernier cluster avec ligne vide rencontrée
  
  !_Repea2:
  MOV edx,ebp ;on sauve l'adresse de début du cluster dans edx
  MOV ecx,dword [v_ligne] ;charge le nombre de ligne total d'un cluster : 16
  ADD ebp,8 ;ebp pointe sur la premiere ligne de données

    
  !_Repea3:
  CMP  ebx,dword [ebp+28] ;compare les 2 clées, si identiques, insere un element à la place courante, et sort
  JE _suite4
  
  CMP dword [ebp+28],0;si la clé est 0, c'est un element pret à etre réécrit, ou inexistant
  JNE _ss1

  CMP esi,0 ;si on a déja une adresse d'un element à reecrire, on la garde
  JNE _ss1
  
  MOV Esi, ebp ;sauvegarde l'adresse de la ligne à réécrire
  MOV edi, edx ;sauvegarde l'adresse du cluster avec la ligne à réécrire
  
  !_ss1:
  ADD ebp,dword [v_datas] ;on passe à la ligne suivante 
  DEC Ecx
  JNZ _Repea3
  
  ;on a pas trouvé la clé 
  MOV eax,ebp
  MOV ebp,dword [edx+4] ;charge l'adresse du cluster suivant
  CMP ebp,0 ;si l'adresse du cluster suivante est vide c'est que c'était le dernier
  JNZ _Repea2 ;sinon on continue pour ce nouveau cluster
  
  MOV ebp, eax
  
  ;on est dans le dernier cluster 
;                                    !CMP esi,0 ;si on a pas trouvé une adresse à ecraser
;                                    !Je _suite3
  MOV ebp,esi ;on se met à l'adresse à ecraser
  MOV edx,edi ;on se met à l'adresse du cluster
  !_suite3:
    ;On ajoute 1 au compteur de ligne du cluster
    INC dword [edx]

    MOV EAX,dword [edx+4] ;vérifie si on est dans le dernier cluster ou si on réécrit une valeur précédente
    CMP Eax, 0
    JNE _suite4
    
   ;si egale 15, on créé un nouveau cluster
  MOV EAX,dword [v_ligne]
  CMP EAX,dword [edx]
  JNE _suite4
  

  ;crée un nouveau cluster
  PUSH edx
   PUSH   dword [v_size_cluster]
   CALL  _PB_AllocateMemory@4
  ;CALL  _PB_AllocateMemory_PURIFIER@4
  CMP eax,0
  JZ _fin111 ;vérifie si on a pu allouer la mémoire
  POP edx
  MOV dword [edx+4],eax ;sauve l'adresse du nouveau cluster dans le cluster précédent
  
  !_suite4:
  LEA esi,dword [p.v_Val1] ;ecrit les nouvelles données
  MOV ecx,dword [v_sz]
  LEA edi,dword [ebp]
  REP MOVSD
  
  MOV eax,ebp
  !_fin111:

  ProcedureReturn
    DisableASM
EndProcedure

ProcedureDLL Hash_Search(*mem,keyX.i,keyY.i)
  EnableASM
  MOV    eax,dword [p.v_keyX] ;1
  MOV    ebx,dword [p.v_keyY] ;2
  MUL    dword [v_keymax] ;1x10000
  ADD    eax,ebx ;eax= 10000+2

  MOV    esi,eax ;clé complete
  ;compression du hash en adresse
  !XOr    edx,edx
  DIV    dword [v_nbSlot] ;1002 modulo 8 = 2
  IMUL   edx,dword [v_size_cluster] ;2x 488 = 976
  ADD    edx,dword [p.p_mem] ;976 + adresse de base
  MOV    ebp,edx
  MOV    ebx,esi ;clé complete
 
  !_Repea4:
  MOV edx,ebp ;on sauve l'adresse de début du cluster dans edx
  MOV ecx,dword [v_ligne] ;charge le nombre de ligne
  ADD ebp,8
  CMP Ecx,0 ;si il y a 0 ligne dans le cluster on sort
  JE _fin66
  
  !_Repea5:
  CMP  ebx,dword [ebp+28] ;compare les 2 clées si on la trouve, on sort
  JE _suite6
 
  ADD ebp,dword [v_datas] ;on passe à la ligne suivante
  DEC Ecx
  JNZ _Repea5
  
  ;on a pas trouvé la clé
  MOV ebp,dword [edx+4] ;charge l'adresse du cluster suivant
  CMP ebp,0
  JNE _Repea4
  
  !_fin66:
  !xor eax,eax
  ProcedureReturn
  !_suite6:
  MOV eax,ebp
  ProcedureReturn
  DisableASM
EndProcedure

ProcedureDLL Hash_SearchDelete(*mem,keyX.i,keyY.i)
  EnableASM
  MOV    eax,dword [p.v_keyX] ;1
  MOV    ebx,dword [p.v_keyY] ;2
  MUL    dword [v_keymax] ;1x10000
  ADD    eax,ebx ;eax= 10000+2

  MOV esi,eax
  ;compression du hash en adresse
  !XOr    edx,edx
  DIV    dword [v_nbSlot] ;1002 modulo 8 = 2
  IMUL   edx,dword [v_size_cluster] ;2x 488 = 976
  ADD    edx,dword [p.p_mem]        ;976 + adresse de base
  MOV    dword [p.p_mem],edx  ;sauvegarde l'adresse de début du cluster
  
  MOV    ebp,edx
  MOV    ebx,esi
  MOV    Eax, dword [v_datas] 
  !_Repea8:
  MOV edx,ebp ;on sauve l'adresse de début du cluster dans edx
  MOV ecx,dword [v_ligne] ;charge le nombre totale de ligne ds un cluster
  ADD ebp,8
  
  !_Repea10:
  NOP
  CMP  ebx,dword [ebp+28] ;compare les 2 clées si on la trouve, on sort
  JE _suite8
 
  ADD ebp,eax ;on passe à la ligne suivante
  DEC Ecx
  JNZ _Repea10
  
  ;on a pas trouvé la clé
  MOV edi,edx ;sauvegarde l'adresse du cluster précédent
  MOV ebp,dword [edx+4] ;charge l'adresse du cluster suivant
  CMP ebp,0
  JNE _Repea8

  !xor eax,eax ;pas trouvé l'élement à effacer, renvoie 0
  ProcedureReturn
  
  !_suite8:
  DEC dword [edx] ;retire une ligne au compteur de ligne
  MOV dword [ebp+28],0; indique que la ligne est effacée en mettant sa clée à 0
  MOV ebx,dword [edx];charge le nombre de ligne
  CMP ebx,0
  JNE _suite10 ;si le cluster n'est pas vide, on sort

  MOV ecx,dword [edx+4] ;charge l'adresse du cluster suivant
  CMP ecx,0 
  JE _suite10 ;si l'adresse du prochain cluster est zero, on sort
  MOV eax, dword [p.p_mem]
  CMP eax,edx
  JE _suite10 ;si on est au premier cluster, on sort
  MOV dword [edi+4],ecx ;met l'adresse du cluster suivant dans le cluster précédent
  ;efface le cluster
  PUSH edx
  CALL  _PB_FreeMemory@4
  ;CALL  _PB_FreeMemory_PURIFIER@4
  !_suite10:
  MOV eax,ebp
  ProcedureReturn 
  DisableASM
EndProcedure

ProcedureDLL Hash_Free(*mem)
  EnableASM
  MOV ebx,dword [v_nbSlot]
  dec ebx
  !_Repea86:
  MOV ebp,ebx
  IMUL ebp,dword [v_size_cluster]
  Add ebp, dword [p.p_mem] ;adresse de base
  !_Repea81:
  MOV esi,dword [ebp+4] ;charge l'adresse du prochain cluster
  push ebp
  CALL  _PB_FreeMemory@4 ;efface le cluster courant
  cmp esi,0
  JE _Suiv81 ;si c'était le dernier, on sort
  mov ebp,esi ; on passe au suivant
  JMP _Repea81
  !_Suiv81:
  dec ebx
  MOV ecx,-1
  CMP ebx,ecx
  Jne _Repea86
  !xor eax,eax
  ProcedureReturn
  DisableASM
EndProcedure

Procedure DisplayTable(*mem)
  Debug " "
  For i=0 To nbslot-1 ;next slot
  *index=i*size_cluster+*mem
    j=0
   Repeat
      Debug "Cluster :"+Str(i)+"+"+Str(j)

    Debug Hex(PeekI(*index))+ " "+Hex(PeekI(*index+4))
    *index1.hash=*index+8
    
    For k=0 To ligne-1
      
      Debug Hex(*index1)+" "+Hex(*index1\Val1)+" "+Hex(*index1\Val2)+" "+Hex(*index1\Val3)+" "+Hex(*index1\Val5)+" "+Hex(*index1\val6)+" "+Hex(*index1\val7)+" "+Hex(*index1\key_unique)
      *index1+datas ;next element

    Next k
    Debug " "
    *index=PeekI(*index+4):j+1
  Until *index=0
  Next i
EndProcedure


;  *tab=hash_New(10,15,10)
; For i=1 To 1000
;   a=i*3:b=i*2
;   hash_add(*tab,a,b,10,10,10,10,10,10,11,0) 
; Next i
; For i=1 To 1000
;   a=i*3:b=i*2
;    hash_SearchDelete(*tab,a,b)
;  Next i
; For i=1 To 1000
;   a=i*3:b=i*2
;   hash_add(*tab,a,b,10,10,10,10,10,10,11,0) 
; Next i 
; For i=1 To 1000
;   a=i*3:b=i*2
;    hash_SearchDelete(*tab,a,b)
;  Next i
; hash_add(*tab,41*3,41*2,1,2,3,4,5,6,7,0) 
;   DisplayTable(*tab)
;  Hash_Free(*tab)
;  DisplayTable(*tab)
;     
;     
;     *a.hash=hash_search(*tab,41*3,41*2)
;     Debug *a\Val1

; IDE Options = PureBasic 5.44 LTS (Windows - x86)
; ExecutableFormat = Shared dll
; CursorPosition = 252
; FirstLine = 23
; Folding = i+
; EnableUnicode
; Executable = librairie hashtable.dll