﻿;*******************************
;* Jump Point Search (B+P optimisation)
;* By Fig 2017
;*******************************
;structure HPA


;structures JPS
Structure Area
  f.l
  g.l
  x.l
  y.l
  open.l
  sens.l
  *parent
  key_unique.l
EndStructure
Structure pt
  x.l
  y.l
EndStructure
Structure pt2
  x1.l
  x2.l
  y.l
EndStructure
Structure pt3
  x.l
  y.l
  g.l
EndStructure
Structure spt
  List spot.pt3()
EndStructure 

;structure A*
Structure A_1
  *Hash_mem
  *Heap_mem
EndStructure


Import "librairie tas.lib"
  Heap_New()
  Heap_Clear(*mem)
  Heap_Free(*mem)
  Heap_AddElement(*mem,*key)
  Heap_GetMin(*mem)
  Heap_Size(*mem)
  Heap_Heapify(*mem,*mem1)
EndImport
Import "librairie hashtable.lib"
  Hash_New(nbSlot.l,nbligne.l,keymax.l)
  Hash_Add(*mem,keyX.l,keyY.l,f.l,g.l,x.l,y.l,open.l,Val6.l,*parent,key_unique.l)
  Hash_Search(*mem,keyX.l,keyY.l)
  Hash_SearchDelete(*mem,keyX.l,keyY.l)
  Hash_Free(*mem)
EndImport

Macro distance(x1,y1,x2,y2)
  ;manathan
  (Abs(x2-x1)+Abs(y2-y1))*10
  ;euclidean
  ;Sqr((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1))*10
EndMacro

Macro AddNode(sens)
  Cgg.l=distance(cx,cy,cxx,cyy)+*adr\g 
  *adr2.Area=Hash_Search(*H,cxx,cyy)
  If *adr2 And *adr\open=1;si le noeud est ouvert on le modifie
    If *adr2\g>Cgg
      *adr2\g=Cgg
      *adr2\f=Cgg+distance(cxx,cyy,gx,gy)
      *adr2\parent=*adr
      Heap_Heapify(*tas,*adr2)
    EndIf
  ElseIf  *adr2 And *adr2\open=2 ;si le noeud est fermé
    If *adr2\g>Cgg
      *adr2\g=Cgg
      *adr2\f=Cgg+distance(cxx,cyy,gx,gy)
      *adr2\open=1
      *adr2\parent=*adr
      *adr2\x=Cxx
      *adr2\y=Cyy
      *tas=Heap_AddElement(*tas,*adr2)
    EndIf
  Else ;le noeud n'a jamais été visité
    *adr2.Area=Hash_add(*H,cxx,cyy,Cgg+distance(cxx,cyy,gx,gy),Cgg,Cxx,Cyy,1,sens,*adr,#NUL)
    *tas=Heap_AddElement(*tas,*adr2)
  EndIf
EndMacro

Macro A_AddNode
  If i=0 Or j=0
    Cgg.l=10+*adr\g
  Else
    Cgg.l=14+*adr\g 
  EndIf
  *adr2.Area=Hash_Search(*H,cxx,cyy)
  If *adr2 And *adr\open=1;si le noeud est ouvert on le modifie
    If *adr2\g>Cgg
      *adr2\g=Cgg
      *adr2\f=Cgg+distance(cxx,cyy,gx,gy)
      *adr2\parent=*adr
      Heap_Heapify(*tas,*adr2)
    EndIf
  ElseIf  *adr2 And *adr2\open=2 ;si le noeud est fermé
    If *adr2\g>Cgg
      *adr2\g=Cgg
      *adr2\f=Cgg+distance(cxx,cyy,gx,gy)
      *adr2\open=1
      *adr2\parent=*adr
      *adr2\x=Cxx
      *adr2\y=Cyy
      *tas=Heap_AddElement(*tas,*adr2)
    EndIf
  Else ;le noeud n'a jamais été visité
    *adr2.Area=Hash_add(*H,cxx,cyy,Cgg+distance(cxx,cyy,gx,gy),Cgg,Cxx,Cyy,1,#NUL,*adr,#NUL)
    *tas=Heap_AddElement(*tas,*adr2)
  EndIf
EndMacro

ProcedureDLL DeleteWall(x.l,y.l)
  EnableASM
  MOV ebx,dword [p.v_x]
  MOV eax,dword [p.v_y] 
  MOV ecx,dword [v_largeur] ;nb d'octets par ligne
  MOV esi,dword [p_area_horizontal]  ;adresse du tableau
  MUL ecx                   
  PUSH eax ;eax=y*nbligne
  XOR edx,edx
  MOV eax,ebx
  MOV ebp,8
  DIV ebp ;divise par x/8  eax resultat, edx reste cad le rang des bits 
  MOV ebp,7
  SUB ebp,edx
  MOV edx,ebp 
  POP ebx ;ebx=y*nbligne
  ADD eax,ebx ;eax=x/8+y*nbligne
  ADD eax,esi ;eax+adress de base
  BTR dword [eax],edx ;met le bit du reste à 0 
  MOV ebx,dword [p.v_y]
  MOV eax,dword [p.v_x]
  MOV ecx,dword [v_largeur] ;nb d'octets par ligne
  MOV esi,dword [p_area_vertical]  ;adresse du tableau
  MUL ecx                   
  PUSH eax ;eax=y*nbligne
  XOR edx,edx
  MOV eax,ebx
  MOV ebp,8
  DIV ebp ;divise par x/8  eax resultat, edx reste cad le rang des bits
  MOV ebp,7
  SUB ebp,edx
  MOV edx,ebp
  POP ebx ;ebx=y*nbligne
  ADD eax,ebx ;eax=x/8+y*nbligne
  ADD eax,esi ;eax+adress de base
  BTR dword [eax],edx ;met le bit du reste à 0
  ProcedureReturn
  DisableASM
EndProcedure

ProcedureDLL.l IsWall(x.l,y.l)
  EnableASM
  MOV ebx,dword [p.v_x]
  MOV eax,dword [p.v_y] 
  MOV ecx,dword [v_largeur] ;nb d'octets par ligne
  MOV esi,dword [p_area_horizontal]  ;adresse du tableau
  MUL ecx                   
  PUSH eax ;eax=y*nbligne
  XOR edx,edx
  MOV eax,ebx
  MOV ebp,8
  DIV ebp ;divise par x/8  eax resultat, edx reste cad le rang des bits
  MOV ebp,7
  SUB ebp,edx
  MOV edx,ebp
  POP ebx ;ebx=y*nbligne
  ADD eax,ebx ;eax=x/8+y*nbligne
  ADD eax,esi ;eax+adress de base
  BT dword [eax],edx ;test le bit
  JC _mur_present
  XOR eax,eax
  ProcedureReturn
  !_mur_present:
  MOV eax,1
  ProcedureReturn
EndProcedure

ProcedureDLL.l IsWall_S(x.l,y.l,*area_1)
  EnableASM
  MOV ebx,dword [p.v_x]
  MOV eax,dword [p.v_y] 
  MOV ecx,dword [v_largeur] ;nb d'octets par ligne
  MOV esi,dword [p.p_area_1]  ;adresse du tableau
  MUL ecx                   
  PUSH eax ;eax=y*nbligne
  XOR edx,edx
  MOV eax,ebx
  MOV ebp,8
  DIV ebp ;divise par x/8  eax resultat, edx reste cad le rang des bits
  MOV ebp,7
  SUB ebp,edx
  MOV edx,ebp
  POP ebx ;ebx=y*nbligne
  ADD eax,ebx ;eax=x/8+y*nbligne
  ADD eax,esi ;eax+adress de base
  BT dword [eax],edx ;test le bit
  JC _mur_present2
  XOR eax,eax
  ProcedureReturn
  !_mur_present2:
  MOV eax,1
  ProcedureReturn
EndProcedure

ProcedureDLL AddWall(x.l,y.l)
  EnableASM
  MOV ebx,dword [p.v_x]
  MOV eax,dword [p.v_y] 
  MOV ecx,dword [v_largeur] ;nb d'octets par ligne
  MOV esi,dword [p_area_horizontal]  ;adresse du tableau
  MUL ecx                   
  PUSH eax ;eax=y*nbligne
  XOR edx,edx
  MOV eax,ebx
  MOV ebp,8
  DIV ebp ;divise par x/8  eax resultat, edx reste cad le rang des bits
  MOV ebp,7
  SUB ebp,edx
  MOV edx,ebp
  POP ebx ;ebx=y*nbligne
  ADD eax,ebx ;eax=x/8+y*nbligne
  ADD eax,esi ;eax+adress de base
  BTS dword [eax],edx ;met le bit du reste à 1
  MOV ebx,dword [p.v_y]
  MOV eax,dword [p.v_x]
  MOV ecx,dword [v_largeur] ;nb d'octets par ligne
  MOV esi,dword [p_area_vertical]  ;adresse du tableau
  MUL ecx                   
  PUSH eax ;eax=y*nbligne
  XOR edx,edx
  MOV eax,ebx
  MOV ebp,8
  DIV ebp ;divise par x/8  eax resultat, edx reste cad le rang des bits
  MOV ebp,7
  SUB ebp,edx
  MOV edx,ebp
  POP ebx ;ebx=y*nbligne
  ADD eax,ebx ;eax=x/8+y*nbligne
  ADD eax,esi ;eax+adress de base
  BTS dword [eax],edx ;met le bit du reste à 1
  ProcedureReturn
  DisableASM
EndProcedure

ProcedureDLL CreateArea(size.l)
  Global ix.l=size
  Global sizX=size>>3;divise par 8 bits
  sizY=size
  Global largeur.l=sizx ;nombre d'octets en largeur
  Global *area_horizontal=AllocateMemory(sizX*sizY)
  Global *area_vertical=AllocateMemory(sizX*sizY)
  If *area_horizontal=0 Or *area_vertical=0:MessageRequester("error","can't allocate memory to CreateArea"):EndIf
  ;mets les murs autours
  For i=0 To size-1
    addwall(i,0)
    addwall(0,i)
    addwall(size-1,i)
    addwall(i,size-1)
  Next i
  ;liste des différents pathfinding
  Global NewList Path.A_1()
EndProcedure

Procedure.l droite_Fast(x.l,y.l,*area_1,Gx.l,Gy.l)
  EnableASM
  MOV ebx,dword [p.v_x]
  MOV eax,dword [p.v_y]
  DEC eax ;passe à la ligne au dessus
  MOV edi,dword [v_largeur] ;nb d'octets par ligne
  MOV esi,dword [p.p_area_1]
  MUL edi
  PUSH eax ;eax=y*nbligne
  XOR edx,edx
  MOV eax,ebx
  MOV ebp,8
  DIV ebp ;divise par x/8  eax resultat, edx reste cad le nombre de bit à décaler
  POP ebx ;ebx=y*nbligne
  ADD eax,ebx ;eax=x/8+y*nbligne
  ADD esi,eax ;esi=eax+adress de base
  MOV ecx,edx ;ecx reste cad nb de bit
  XOR ebp,ebp ;met à zero le total de déplacement
  !_bouclette:
  ;Au dessus EAX
  PUSH ebp ;sauvegarde le déplacement total
  PUSH esi ;sauvegarde esi pour boucler sur l'adresse de l'emplacement... Vérifier si nécessaire !!!!!
  MOV eax,dword [esi] ;charge les 32 bits au dessus
  BSWAP eax           ;remets les octets dans l'ordre
  SHL eax,CL          ;décale jusqu'a ce qu'on soit aligné pour la ligne centrale
                      ;function forced
  MOV ebx,eax
  NOT ebx ; !B
  SHR eax,1 ;>>1
  AND eax,ebx ;B>>1 & !B
  SHR eax,cl  ;fait disparaitre le dernier bit
  SHL eax,cl
  ;Courant EDX
  LEA esi,[esi+edi] ;passe à la ligne centrale
  MOV edx,dword [esi] ;charge les 32 bits des murs
  BSWAP edx           ;remets les octets dans l'ordre
  SHL edx,CL          ;décale jusqu'a ce qu'on soit aligné pour la ligne centrale
                      ;Au dessous EBX
  LEA esi,[esi+edi]   ;passe à la ligne en dessous
  MOV ebx,dword [esi] ;charge les 32 bits des murs
  BSWAP ebx           ;remets les octets dans l'ordre
  SHL ebx,CL          ;décale jusqu'a ce qu'on soit aligné pour la ligne centrale
                      ;function forced
  MOV ebp,ebx
  NOT ebp ; !B
  SHR ebx,1 ;>>1
  AND ebx,ebp ;B>>1 & !B
  SHR ebx,cl  ;fait disparaitre le dernier bit
  SHL ebx,cl
  OR Eax,EDX
  OR Eax,EBX
  BSR Eax,eax ;de gauche à droite, rang du 1er bit rencontré. 4=>2 ; 2=>1 ; 1=>0
  JNZ  _HITWALL       ;on va sortir car il y a un mur quelque part
                      ;on passe au DWord suivant
  POP esi             ;recupere esi
  POP ebp             ;recupere emplacement total
  MOV ebx,31
  SUB ebx,ecx
  ADD ebp,ebx ;rajoute au total l'emplacement
  LEA esi, [esi+3] ;passe aux 32 bits suivant en ajoutant 3 octets
  MOV ecx,7        ;décale de 7 bits
  JMP _bouclette
  !_HITWALL:
  POP esi
  POP ebp 
  BSR edx,edx ;edx Bn pour 1000 renvoie la position du 1er bit rencontré en lisant de gauche à droite la ligne centrale
  CMP eax,edx 
  JBE  _DeadEnd        ;si eax plus petit ou égal, DeadEnd
                       ;Jump Point découvert                     
  MOV ebx,30
  SUB ebx,eax
  ADD ebx,ebp ;rajoute au total l'emplacement
  ADD ebx,dword [p.v_x] ;ebx contient la coordonnée X du jump point
  MOV ecx,dword [p.v_y]
  MOV edx,dword [p.v_Gy]
  CMP ecx,edx
  JNE _renvoi1 ; si y goal et y différent, on renvoie le jump point trouvé dans eax
  MOV ecx, dword [p.v_Gx]
  MOV eax,dword [p.v_x]
  CMP eax,ecx
  JA _renvoi1 ;si X > goal X on sort en renvoyant le Jump Point trouvé dans eax
  CMP ebx,ecx
  JB _renvoi1 ;si jump point X < Goal X on sort 
  MOV eax, ecx;on bloque sur X Goal car il a été trouvé
  ProcedureReturn
  !_renvoi1:
  MOV eax,ebx
  ;renvoie l'emplacement du jump point
  ProcedureReturn
  !_DeadEnd:
  MOV ebx,31
  SUB ebx,eax
  ADD ebx,ebp ;rajoute au total l'emplacement
  JZ _on_est_sur_un_mur
  ADD ebx,dword [p.v_x] ;coordonnée du mur
  MOV ecx,dword [p.v_y]
  MOV edx,dword [p.v_Gy]
  CMP ecx,edx
  JNE _renvoi2 ; si y goal et y courant différent, on sort
  MOV ecx, dword [p.v_Gx]
  MOV eax,dword [p.v_x]
  CMP eax,ecx
  JA _renvoi2 ;si x>goal X on sort 
  CMP ebx,ecx
  JB _renvoi2 ;si WallX < Goal X on sort 
  MOV eax, ecx;on bloque sur le Goal
  ProcedureReturn
  !_renvoi2:
  XOR eax,eax ;retourne zero car deadend
  ProcedureReturn
  !_on_est_sur_un_mur:
  MOV eax,dword [v_ix]
  ProcedureReturn
  DisableASM
EndProcedure

Procedure.l gauche_Fast(x.l,y.l,*area_1,Gx.l,Gy.l)
  EnableASM
  MOV ebx,dword [p.v_x]
  MOV eax,dword [p.v_y]
  DEC eax ;passe à la ligne au dessus
  MOV edi,dword [v_largeur] ;nb d'octets par ligne
  MOV esi,dword [p.p_area_1]
  MUL edi
  PUSH eax ;eax=y*nbligne
  XOR edx,edx
  MOV eax,ebx
  MOV ebp,8
  DIV ebp ;divise par x/8  eax resultat, edx reste cad le nombre de bit à décaler
  POP ebx ;ebx=y*nbligne
  ADD eax,ebx ;eax=x/8+y*nbligne
  ADD esi,eax ;esi=eax+adress de base
  SUB esi,3   ;recule de 3 octets
  MOV ecx,7   ;reste ecx et edx complément à 7
  SUB ecx,edx  
  XOR ebp,ebp ;met à zero le total de déplacement
  !_bouclette2:
  ;Au dessus EAX
  PUSH ebp ;sauvegarde le déplacement total
  PUSH esi ;sauvegarde esi pour boucler sur l'adresse de l'emplacement... Vérifier si nécessaire !!!!!
  MOV eax,dword [esi] ;charge les 32 bits au dessus
  BSWAP eax           ;remets les octets dans l'ordre
  SHR eax,CL          ;décale jusqu'a ce qu'on soit aligné pour la ligne du dessus
  MOV ebx,eax
  NOT ebx ; !B
  SHL eax,1 ;<<1
  AND eax,ebx ;B<<1 & !B
  SHL eax,cl
  SHR eax,cl
  ;Courant EDX
  LEA esi,[esi+edi] ;passe à la ligne centrale
  MOV edx,dword [esi] ;charge les 32 bits des murs
  BSWAP edx           ;remets les octets dans l'ordre
  SHR edx,CL          ;décale jusqu'a ce qu'on soit aligné pour la ligne centrale
                      ;Au dessous EBX
  LEA esi,[esi+edi]   ;passe à la ligne en dessous
  MOV ebx,dword [esi] ;charge les 32 bits des murs
  BSWAP ebx           ;remets les octets dans l'ordre
  SHR ebx,CL          ;décale jusqu'a ce qu'on soit aligné pour la ligne du dessous
  MOV ebp,ebx
  NOT ebp ; !B
  SHL ebx,1 ;<<1
  AND ebx,ebp ;B<<1 & !B
  SHL ebx,cl
  SHR ebx,cl
  OR Eax,EDX
  OR Eax,EBX
  BSF Eax,eax ;de droite à gauche, rang du 1er bit rencontré.
  JNZ  _HITWALL2       ;on va sortir car il y a un mur quelque part
                       ;on passe au DWord suivant
  POP esi              ;recupere esi
  POP ebp              ;recupere emplacement total
  MOV ebx,31
  SUB ebx,ecx
  ADD ebp,ebx ;rajoute au total l'emplacement
  LEA esi, [esi-3] ;passe aux 32 bits suivant en ajoutant 3 octets
  MOV ecx,7        ;décale de 7 bits
  JMP _bouclette2
  !_HITWALL2:
  POP esi
  POP ebp
  BSF edx,edx ;edx Bn pour 1000 renvoie la position du 1er bit rencontré en lisant de droite à gauche la ligne centrale
  JNZ _suite556 ;si ligne centrale vide, edx reste à 0, ZF mis à 1 néanmoins.
  MOV edx,255   ;mets à l'infini
  !_suite556:   ;compare le plus grand eax et edx
  CMP eax,edx 
  JAE  _DeadEnd2        ;si eax plus petit ou égal, DeadEnd
  DEC EAX
  ADD eax,ebp ;rajoute au total l'emplacement
  MOV ebx,dword [p.v_x] ;ebx contient la coordonnée X du jump point
  SUB ebx,eax           ;ebx contient la coordonnée X du jump point
                        ;vérifie si on a trouvé le goal entre temps
  MOV ecx,dword [p.v_y]
  MOV edx,dword [p.v_Gy]
  CMP ecx,edx
  JNE _renvoi4 ; si y goal et y différent, on renvoie le jump point trouvé dans eax
  MOV ecx, dword [p.v_Gx]
  MOV eax,dword [p.v_x]
  CMP eax,ecx
  JB _renvoi4 ;si X < goal X on sort en renvoyant le Jump Point trouvé dans eax
  CMP ebx,ecx
  JA _renvoi4 ;si jump point X < Goal X on sort 
  MOV eax, ecx;on bloque sur X Goal car il a été trouvé
  ProcedureReturn
  !_renvoi4:
  MOV eax,ebx
  ;renvoie l'emplacement du jump point
  ProcedureReturn
  !_DeadEnd2:
  ;DEC eax INc ptetre ?
  ADD eax,ebp ;rajoute au total l'emplacement
  JZ _on_est_sur_un_mur2
  MOV ebx,dword [p.v_x]
  SUB ebx,eax ;coordonnée du mur
              ;vérifie si on a trouvé le goal
  MOV ecx,dword [p.v_y]
  MOV edx,dword [p.v_Gy]
  CMP ecx,edx
  JNE _renvoi3 ; si y goal et y courant différent, on sort
  MOV ecx, dword [p.v_Gx]
  MOV eax,dword [p.v_x]
  CMP eax,ecx
  JB _renvoi3 ;si x<goal X on sort 
  CMP ebx,ecx
  JA _renvoi3 ;si WallX > Goal X on sort 
  MOV eax,ecx ;on bloque sur le Goal
  ProcedureReturn
  !_renvoi3:
  XOR eax,eax ;retourne zero car deadend
  ProcedureReturn
  !_on_est_sur_un_mur2:
  MOV eax,dword [v_ix]
  ProcedureReturn
  DisableASM
EndProcedure

ProcedureDLL.l JPS_Fast(sx.l,sy.l,gx.l,gy.l,*p.spt)
  *H=Hash_New(Int(ix/10),15,ix)
  ClearList(*p\spot())
  *tas=Heap_New()
  ; first node (start node) in open list
  *a=Hash_Add(*H,Sx,Sy,distance(Sx,Sy,gx,gy),0,sx,sy,1,#NUL,0,#NUL)
  If *a=0:MessageRequester("debug","l'élement n'a pas pu être ajouté à la Hash_table "):EndIf
  *tas=Heap_AddElement(*tas,*a);@Area(Sx,Sy))
  If *tas=0:MessageRequester("debug","Un element n'a pas pu etre ajouté au tas"):EndIf
  While Heap_Size(*tas)   
    ;get the minimum f node
    *adr.area=Heap_GetMin(*tas)
    Cx=*adr\x:Cy.l=*adr\y:Cg.l=*adr\g:sens=*adr\sens
    If cx=Gx And cy=Gy:Break:EndIf 
    Debug "noeud examiné "+Str(cx)+"/"+Str(cy),1
    ;{ RIGHT
    If sens<>2
    x1=cx+1:y1=cy
    cxx=droite_Fast(x1,y1,*area_horizontal,Gx,Gy):cyy=y1
    Debug Str(cxx)+"\"+Str(cyy)
    If cxx And cxx<>ix
      AddNode(1)
    EndIf
    EndIf
    ;LEFT
    If sens<>1
    x1=cx-1:y1=cy
    cxx=gauche_Fast(x1,y1,*area_horizontal,Gx,Gy):cyy=y1
    Debug Str(cxx)+"\"+Str(cyy)
    If cxx And cxx<>ix
      AddNode(2)
    EndIf
    EndIf
    ;down
    If sens<>4
    x1=cx:y1=cy+1
    cyy=droite_Fast(y1,x1,*area_vertical,Gy,Gx):cxx=x1
    Debug Str(cxx)+"\"+Str(cyy)
    If cyy And cyy<>ix
      AddNode(3)            
    EndIf    
    EndIf
    ;UP
    If sens<>3
    x1=cx:y1=cy-1
    cyy=gauche_Fast(y1,x1,*area_vertical,Gy,Gx):cxx=x1
    Debug Str(cxx)+"\"+Str(cyy)
    If cyy And cyy<>ix
      AddNode(4)            
    EndIf
    EndIf
    ;diagonal down-right
    If sens<>8
    x1=cx:y1=cy
    Repeat
      If iswall(x1+1,y1) And iswall(x1,y1+1):Break:EndIf
      x1+1:y1+1
      ;right
      cxx=droite_Fast(x1,y1,*area_horizontal,Gx,Gy):cyy=y1
      Debug Str(cxx)+"\"+Str(cyy)
      If cxx
        If cxx=ix:Break:EndIf
        AddNode(5)
      EndIf
      ;down
      cyy=droite_Fast(y1,x1,*area_vertical,Gy,Gx):cxx=x1
      Debug Str(cxx)+"\"+Str(cyy)
      If cyy
        AddNode(5)         
      EndIf
    ForEver
    EndIf
    ; diagonal Up-Right
    If sens<>7
    x1=cx:y1=cy
    Repeat
      If iswall(x1+1,y1) And iswall(x1,y1-1):Break:EndIf
      x1+1:y1-1
      ;Right
      cxx=droite_Fast(x1,y1,*area_horizontal,Gx,Gy):cyy=y1
      If cxx
        If cxx=ix:Break:EndIf
        AddNode(6)
      EndIf
      ;Up
      cyy=gauche_Fast(y1,x1,*area_vertical,Gy,Gx):cxx=x1
      If cyy            
        AddNode(6)
      EndIf
    ForEver
    EndIf
    
    ;diagonal Down-Left
    If sens<>6
    x1=cx:y1=cy
    Repeat
      If (iswall(x1-1,y1) And iswall(x1,y1+1)):Break:EndIf
      x1-1:y1+1
      ;Left
      cxx=gauche_Fast(x1,y1,*area_horizontal,Gx,Gy):cyy=y1
      If cxx
        If cxx=ix:Break:EndIf
        AddNode(7)
      EndIf
      ;Down
      cyy=droite_Fast(y1,x1,*area_vertical,Gy,Gx):cxx=x1
      If cyy                                       
        AddNode(7)
      EndIf
    ForEver
    EndIf
    ;diagonal Up-Left
    If sens<>5
    x1=cx:y1=cy
    Repeat
      If iswall(x1,y1-1) And iswall(x1-1,y1):Break:EndIf
      x1-1:y1-1
      ;Left
      cxx=gauche_Fast(x1,y1,*area_horizontal,Gx,Gy):cyy=y1
      Debug Str(cxx)+"\"+Str(cyy)
      If cxx
        If cxx=ix:Break:EndIf
        AddNode(8)
      EndIf
      ;Up
      cyy=gauche_Fast(y1,x1,*area_vertical,Gy,Gx):cxx=x1
      Debug Str(cxx)+"\"+Str(cyy)
      If cyy
        AddNode(8)
      EndIf
    ForEver
    EndIf
    ;}
    *adr\open=2;close the current node
  Wend
  ;no solution send back "0"
  If cx<>Gx Or cy<>Gy
    Heap_Free(*tas)
    Hash_Free(*H)
    ProcedureReturn 0
  EndIf
  Heap_Free(*tas) ;free binary heap memory
                  ;restitue la solution trouvée sous forme d'une liste
  *parent.area=Hash_Search(*H,gx,gy);@area(gx,gy)
  Repeat
    x=*parent\x
    y=*parent\y
    InsertElement(*p\spot())
    *p\spot()\x=x
    *p\spot()\y=y
    *parent=*parent\parent
  Until *parent=0
  prevx=Sx:prevy=Sy
  ForEach *p\spot()
    x=*p\spot()\x
    y=*p\spot()\y
    c=Abs(x-prevx)
    d=Abs(y-prevy)
    If x<>prevx And y<>prevy And c<>d
      a=x-prevx
      b=y-prevy
      s=1
      If Sign(a)<>Sign(b):s=-1:EndIf
      If c<d
        x=prevx+a
        y=prevy+a*s
      ElseIf d<c
        x=prevx+b*s
        y=prevy+b
      EndIf
      InsertElement(*p\spot())
      *p\spot()\x=x
      *p\spot()\y=y
    EndIf
    prevx=x:prevy=y
  Next
  Hash_Free(*H)
  ;send back 1: path has been found
  ProcedureReturn 1
EndProcedure

Procedure.l droite(x.l,y.l,*area_1,Gx.l,Gy.l)
  x1=x
  If Iswall_S(x,y,*area_1):ProcedureReturn ix:EndIf
  While Iswall_S(x,y,*area_1)<>0
    If IsWall_S(x,y-1,*area_1) Or IsWall_S(x,y+1,*area_1):Goto vrun:EndIf
    x+1
  Wend
  If Gy=y And gx>=x1 And gx<=x:ProcedureReturn gx:EndIf
  ProcedureReturn 0
  vrun:
  If Gy=y And gx>=x1 And gx<=x:ProcedureReturn gx:EndIf
  ProcedureReturn x
EndProcedure

Procedure.l gauche(x.l,y.l,*area_1,Gx.l,Gy.l)
  If Iswall_S(x,y,*area_1):ProcedureReturn ix:EndIf
  While Iswall_S(x,y,*area_1)<>0
    If IsWall_S(x,y-1,*area_1) Or IsWall_S(x,y+1,*area_1):Goto vrun2:EndIf
    x-1
  Wend
  If Gy=y And gx<=x1 And gx>=x:ProcedureReturn gx:EndIf
  ProcedureReturn 0
  vrun2:
  If Gy=y And gx<=x1 And gx>=x:ProcedureReturn gx:EndIf
  ProcedureReturn x
EndProcedure

ProcedureDLL.l JPS(sx.l,sy.l,gx.l,gy.l,*p.spt)
;   ;not fonctionnal yet !!!!!!!!!
;   *H=Hash_New(Int(ix/10),15,ix)
;   ClearList(*p\spot())
;   *tas=Heap_New()
;   If *tas=0:MessageRequester("debug","le tas n'a pas pu être créé "):EndIf
;   ; first node (start node) in open list
;   *a=Hash_Add(*H,Sx,Sy,distance(Sx,Sy,gx,gy),0,sx,sy,1,#NUL,0,#NUL)
;   If *a=0:MessageRequester("debug","l'élement n'a pas pu être ajouté à la Hash_table "):EndIf
;   *tas=Heap_AddElement(*tas,*a);@Area(Sx,Sy))
;   If *tas=0:MessageRequester("debug","Un element n'a pas pu etre ajouté au tas"):EndIf
;   While Heap_Size(*tas)   
;     ;get the minimum f node
;     *adr.area=Heap_GetMin(*tas)
;     Cx=*adr\x:Cy.l=*adr\y:Cg.l=*adr\g
;     If cx=Gx And cy=Gy:Break:EndIf 
;     Debug "noeud examiné "+Str(cx)+"/"+Str(cy),1
;     ;{ RIGHT
;     x1=cx+1:y1=cy
;     cxx=droite(x1,y1,*area_horizontal,Gx,Gy):cyy=y1
;     Debug Str(cxx)+"\"+Str(cyy)
;     If cxx And cxx<>ix
;       AddNode()
;     EndIf
;     ;LEFT
;     x1=cx-1:y1=cy
;     cxx=gauche(x1,y1,*area_horizontal,Gx,Gy):cyy=y1
;     Debug Str(cxx)+"\"+Str(cyy)
;     If cxx And cxx<>ix
;       AddNode()
;     EndIf
;     ;down
;     x1=cx:y1=cy+1
;     cyy=droite(y1,x1,*area_vertical,Gy,Gx):cxx=x1
;     Debug Str(cxx)+"\"+Str(cyy)
;     If cyy And cyy<>ix
;       AddNode()            
;     EndIf    
;     ;UP
;     x1=cx:y1=cy-1
;     cyy=gauche(y1,x1,*area_vertical,Gy,Gx):cxx=x1
;     Debug Str(cxx)+"\"+Str(cyy)
;     If cyy And cyy<>ix
;       AddNode            
;     EndIf    
;     ;diagonal down-right
;     x1=cx:y1=cy
;     Repeat
;       If iswall(x1+1,y1) And iswall(x1,y1+1):Break:EndIf
;       x1+1:y1+1
;       ;right
;       cxx=droite(x1,y1,*area_horizontal,Gx,Gy):cyy=y1
;       Debug Str(cxx)+"\"+Str(cyy)
;       If cxx
;         If cxx=ix:Break:EndIf
;         AddNode
;       EndIf
;       ;down
;       cyy=droite(y1,x1,*area_vertical,Gy,Gx):cxx=x1
;       Debug Str(cxx)+"\"+Str(cyy)
;       If cyy
;         AddNode            
;       EndIf
;     ForEver     
;     ; diagonal Up-Right
;     x1=cx:y1=cy
;     Repeat
;       If iswall(x1+1,y1) And iswall(x1,y1-1):Break:EndIf
;       x1+1:y1-1
;       ;Right
;       cxx=droite(x1,y1,*area_horizontal,Gx,Gy):cyy=y1
;       If cxx
;         If cxx=ix:Break:EndIf
;         AddNode
;       EndIf
;       ;Up
;       cyy=gauche(y1,x1,*area_vertical,Gy,Gx):cxx=x1
;       If cyy            
;         AddNode
;       EndIf
;     ForEver
;     
;     
;     ;diagonal Down-Left
;     x1=cx:y1=cy
;     Repeat
;       If (iswall(x1-1,y1) And iswall(x1,y1+1)):Break:EndIf
;       x1-1:y1+1
;       ;Left
;       cxx=gauche(x1,y1,*area_horizontal,Gx,Gy):cyy=y1
;       If cxx
;         If cxx=ix:Break:EndIf
;         AddNode
;       EndIf
;       ;Down
;       cyy=droite(y1,x1,*area_vertical,Gy,Gx):cxx=x1
;       If cyy                                       
;         AddNode
;       EndIf
;     ForEver
;     ;diagonal Up-Left
;     x1=cx:y1=cy
;     Repeat
;       If iswall(x1,y1-1) And iswall(x1-1,y1):Break:EndIf
;       x1-1:y1-1
;       ;Left
;       cxx=gauche(x1,y1,*area_horizontal,Gx,Gy):cyy=y1
;       Debug Str(cxx)+"\"+Str(cyy)
;       If cxx
;         If cxx=ix:Break:EndIf
;         AddNode
;       EndIf
;       ;Up
;       cyy=gauche(y1,x1,*area_vertical,Gy,Gx):cxx=x1
;       Debug Str(cxx)+"\"+Str(cyy)
;       If cyy
;         AddNode
;       EndIf
;     ForEver
;     ;}
;     *adr\open=2;close the current node
;   Wend
;   ;no solution send back "0"
;   If cx<>Gx Or cy<>Gy
;     Heap_Free(*tas)
;     Hash_Free(*H)
;     ProcedureReturn 0
;   EndIf
;   Heap_Free(*tas) ;free binary heap memory
;                   ;restitue la solution trouvée sous forme d'une liste
;   *parent.area=Hash_Search(*H,gx,gy);@area(gx,gy)
;   Repeat
;     x=*parent\x
;     y=*parent\y
;     InsertElement(*p\spot())
;     *p\spot()\x=x
;     *p\spot()\y=y
;     *parent=*parent\parent
;   Until *parent=0
;   prevx=Sx:prevy=Sy
;   ForEach *p\spot()
;     x=*p\spot()\x
;     y=*p\spot()\y
;     c=Abs(x-prevx)
;     d=Abs(y-prevy)
;     If x<>prevx And y<>prevy And c<>d
;       a=x-prevx
;       b=y-prevy
;       s=1
;       If Sign(a)<>Sign(b):s=-1:EndIf
;       If c<d
;         x=prevx+a
;         y=prevy+a*s
;       ElseIf d<c
;         x=prevx+b*s
;         y=prevy+b
;       EndIf
;       InsertElement(*p\spot())
;       *p\spot()\x=x
;       *p\spot()\y=y
;     EndIf
;     prevx=x:prevy=y
;   Next
;   Hash_Free(*H)
;   ;send back 1: path has been found
;   ProcedureReturn 1
EndProcedure

ProcedureDLL HPA_ScanLineFill(x1.l,y1.l,x2.l,y2.l)
  Protected NewList explore.pt() ;x,y
    Protected Dim check.i(ix,ix)
    AddElement(explore())
    explore()\x=x1
    explore()\y=y1
    check(x1,y1)=1
    Repeat
      x=Explore()\x
      y=Explore()\y
      DeleteElement(Explore())
      xi=x  
      xj=x
      ;agrandit vers la gauche
      While Iswall(xi,y)=0
        check(xi,y)=1
        xi-1
      Wend
      xi+1
      ;Agrandit vers la droite
      While IsWall(xj,y)=0
        check(xj,y)=1
        xj+1
      Wend
      xj-1     
      ;nord
      yy=y-1     
      If yy>0
        SectionFound = 0
        For i=xi To xj
          If i=x2 And yy=y2:ProcedureReturn 1:EndIf
          If check(i,yy):Continue:EndIf
          If IsWall(i,yy)=0
            If SectionFound=0
              AddElement(Explore())
              Explore()\x=i
              Explore()\y=yy
              SectionFound = 1
            EndIf
          Else
            SectionFound = 0         
          EndIf
        Next i
      EndIf
      ;sud
      yy+2
      If yy<ix
        SectionFound = 0
        For i=xi To xj
          If check(i,yy):Continue:EndIf
          If IsWall(i,yy)=0
            If SectionFound=0
              AddElement(Explore())
              Explore()\x=i
              Explore()\y=yy
              SectionFound = 1
            EndIf
          Else
            SectionFound = 0         
          EndIf
        Next i
      EndIf    
    Until ListSize(explore())=0
  ;vérifie les gates  
  ;   ForEach gate()
  ;     If check(gate()\x,gate()\y):EndIf
  ;   Next
    
    ;If check(x2,y2)=1:ProcedureReturn 1:EndIf
    ProcedureReturn 0
  ;  ; MessageRequester("Temps", Str((ElapsedMilliseconds()-time)))
EndProcedure

ProcedureDLL A_NewPath()
  *a=AddElement(Path())
  Path()\Hash_mem=Hash_New(ix,15,ix)
  Path()\Heap_mem=Heap_New()
  ProcedureReturn *a
EndProcedure

;regular A*
ProcedureDLL.l A_pathfind(*path.A_1,Sx.l,Sy.l,Gx.l,Gy.l,*p.spt)
  ClearList(*p\spot())
  If Heap_Size(*path\Heap_mem)=0
    *a=Hash_Add(*path\Hash_mem,Sx,Sy,distance(Sx,Sy,Gx,Gy),0,Sx,Sy,0,#NUL,0,#NUL)
    Heap_AddElement(*path\Heap_mem,*a)
  EndIf
  *H=*Path\Hash_mem:*tas=*Path\Heap_mem
  While Heap_Size(*tas)
    *adr.area=Heap_GetMin(*tas)
    Cx=*adr\x:Cy.l=*adr\y:Cg.l=*adr\g
    If cx=Gx And cy=Gy:Break:EndIf 
    For j=-1 To 1
      cyy=cy+j
      For i=-1 To 1
        If j=0 And i=0:Continue:EndIf
        cxx=cx+i
        If IsWall(Cxx,Cyy)=0 
          If j<>0 And i<>0
            If IsWall(cx,cy+j)=0 Or IsWall(cx+i,cy)=0 ;empeche les diagonales entre deux blocs 
              A_AddNode
            EndIf  
          Else
            A_AddNode
          EndIf
        EndIf
      Next i
    Next j
    *adr\open=2;close the current node
  Wend
  ;soit il n'y a plus de noeud, soit on a trouvé le Goal
  ;no solution send back "0"
  If cx<>Gx Or cy<>Gy
    *Path\Heap_mem=Heap_Clear(*tas) 
    Hash_Free(*H)
    *Path\Hash_mem=Hash_New(Int(ix/10),15,ix)
    ProcedureReturn 0
  EndIf
  If *p=0
    *Path\Heap_mem=Heap_Clear(*tas) 
    Hash_Free(*H)
    *Path\Hash_mem=Hash_New(Int(ix/10),15,ix)
    ProcedureReturn 1    
  EndIf
  ;restitue la solution trouvée sous forme d'une liste
  If *p<>0
    *parent.area=Hash_Search(*H,gx,gy);@area(gx,gy)
    Repeat
      x=*parent\x
      y=*parent\y
      InsertElement(*p\spot())
      *p\spot()\x=x
      *p\spot()\y=y
      *parent=*parent\parent
    Until *parent=0
  EndIf
  *Path\Heap_mem=Heap_Clear(*tas) 
  Hash_Free(*H)
  *Path\Hash_mem=Hash_New(Int(ix/10),15,ix)
  ProcedureReturn 1
EndProcedure



; Structure Agent1
;   Sx.l
;   Sy.l
;   team.l
;   color.l
;   *H ;hashtable
;   *Heap ;tas
;   List JPlist.pt() ;liste des points JPS du chemin
;   Gx.l
;   Gy.l
; EndStructure
; Global NewList Agent.Agent1()
ProcedureDLL.l NewAgent(x,y,team,color)
;   *A=AddElement(Agent())
;   Agent()\Sx=x
;   Agent()\Sy=y
;   Agent()\Gx=x
;   Agent()\Gy=y
;   Agent()\team=team
;   Agent()\color=color
;   Agent()\H=Hash_New(Int(ix/10),15,ix)
;   Agent()\Heap=Heap_New()
;   
;   ProcedureReturn *A
EndProcedure

;**************************************************************************
;*  Cooperative Pathfinding
;**************************************************************************
; CreateArea(32)
; Define p.spt
; ix=32
; lt=10
; 
; Macro DisplayArea()
;   StartDrawing(ImageOutput(0))
;   For j=0 To ix
;     For i=0 To ix
;       If IsWall(i,j):Box(i*lt,j*lt,lt,lt,#Blue):EndIf
;     Next i
;   Next j
;   StopDrawing()
; EndMacro
; 
;   If OpenWindow(0, 0, 0, ix*lt, ix*lt, "CanvasGadget", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
;     CanvasGadget(0,0,0, ix*lt, ix*lt)
;     CreateImage(0,ix*lt,ix*lt)
;     NewAgent(2,2,0,#Yellow)
;     DisplayArea()
;     Repeat
;       Event = WaitWindowEvent()
;       StartDrawing(CanvasOutput(0))
;       DrawImage(ImageID(0),0,0) ;efface le canvas
;       ForEach agent()
;         Box(agent()\x*lt,agent()\y*lt,lt,lt,agent()\color)
;       Next
;       StopDrawing()
;       If Event = #PB_Event_Gadget And EventGadget() = 0 
;         If EventType() = #PB_EventType_LeftButtonDown Or (EventType() = #PB_EventType_MouseMove And GetGadgetAttribute(0, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton)
; 
;         EndIf
;       EndIf    
;       
;     Until Event = #PB_Event_CloseWindow
;   EndIf

; IDE Options = PureBasic 5.44 LTS (Windows - x86)
; ExecutableFormat = Shared dll
; CursorPosition = 1039
; FirstLine = 274
; Folding = AwA-
; EnableAsm
; EnableUnicode
; EnableXP
; Executable = librairie jps.dll